unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,tabprn, ComCtrls,unit1, Spin;

type
  Toform = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Label4: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Edit8: TEdit;
    Label9: TLabel;
    Panel2: TPanel;
    RadioButton3: TRadioButton;
    Label10: TLabel;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    RadioButton11: TRadioButton;
    Label11: TLabel;
    Edit9: TEdit;
    Panel1: TPanel;
    CheckBox2: TCheckBox;
    CheckBox1: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    Label13: TLabel;
    Edit11: TEdit;
    Label14: TLabel;
    Edit12: TEdit;
    RadioButton12: TRadioButton;
    RadioButton13: TRadioButton;
    RadioButton14: TRadioButton;
    SpinEdit1: TSpinEdit;
    Label12: TLabel;
    Edit10: TEdit;
    Label15: TLabel;
    Edit13: TEdit;
    CheckBox7: TCheckBox;
    Edit14: TEdit;
    Label16: TLabel;
    CheckBox8: TCheckBox;
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure RadioButton12Click(Sender: TObject);
    procedure RadioButton13Click(Sender: TObject);
    procedure RadioButton14Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure Edit11KeyPress(Sender: TObject; var Key: Char);
    procedure CheckBox8Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  procedure getoptions;

var
  oform: Toform;

implementation

{$R *.DFM}

procedure Toform.CheckBox1Click(Sender: TObject);
begin
if checkbox1.checked then begin
 checkbox2.checked:=false;
 checkbox5.checked:=false;
end;
end;

procedure Toform.CheckBox2Click(Sender: TObject);
begin
if checkbox2.checked then begin
 checkbox1.checked:=false;
 checkbox5.checked:=false;
end;
end;

procedure Toform.CheckBox3Click(Sender: TObject);
begin
 if checkbox3.checked then begin
  checkbox4.checked:=false;
  checkbox6.checked:=false;
 end;
end;

procedure Toform.CheckBox4Click(Sender: TObject);
var i:integer;
begin
 if checkbox4.checked then begin
  checkbox3.checked:=false;
  checkbox6.checked:=false;
  for i:=1 to np do begin
   d[i]:=strtofloat(edit13.text);
   spinedit1.Value:=i; edit11.Text:=floattostr(d[i]);
  end;
 end;
end;

procedure Toform.Button1Click(Sender: TObject);
const nf0=2000;
 allrewrite:boolean=false;
var ts:string;
 dlgres,ic,nfl,i,ib:integer;
 result:tsearchrec;
 fls:array[1..nf0] of string;
 dls:array[1..nf0] of integer;
begin
 getoptions;
 close;
 if checkbox8.Checked then begin {multiple-file processing:}
  ts:=extractfiledir(form1.opendialog1.filename);
  nfl:=0;
  ic:=findfirst(ts+'\*.*',faAnyFile,result);
  while (ic=0) do begin
   nfl:=nfl+1;
   if nfl>nf0 then begin showmessage('Too many files');exit;end;
   fls[nfl]:=result.name;
   if (result.attr>=16) and (result.size=0) then begin
    dls[nfl]:=1;
   end else begin
    if not(ansisametext(extractfileext(fls[nfl]),'.tab')) then dls[nfl]:=1 else dls[nfl]:=0;
   end;
   ic:=findnext(result);
  end;
  findclose(result);
  ib:=0;
  for i:=1 to nfl do begin
   if dls[i]=0 then begin
    ib:=ib+1;
    currenttab:=fls[i];
    loadfile;
    infos:='';
    if spectrumloaded then begin
     peakdef;
     dospectrum;
     picture;
     ts:=extractfilename(currenttab);
     ts:=copy(ts,1,length(ts)-4);
     if oform.radiobutton3.checked then ts:=ts+'d.prn';
     if oform.radiobutton4.checked then ts:=ts+'r.prn';
     if oform.radiobutton12.checked then ts:=ts+'x.prn';
     if oform.radiobutton13.checked then ts:=ts+'y.prn';
     if oform.radiobutton5.checked then ts:=ts+'ram.prn';
     if oform.radiobutton6.checked then ts:=ts+'roa.prn';
     if oform.radiobutton7.checked then ts:=ts+'roa.prn';
     if oform.radiobutton8.checked then ts:=ts+'roa.prn';
     if oform.radiobutton9.checked then ts:=ts+'ram.prn';
     if oform.radiobutton10.checked then ts:=ts+'roa.prn';
     if oform.radiobutton11.checked then ts:=ts+'ins.prn';
     if oform.radiobutton14.checked then ts:=ts+'ram.prn';
     filenameprn:=ts;
     dlgres:=MRYES;
     if fexists(filenameprn) and not(allrewrite) then begin
      dlgres:=MessageDlg('Rewrite existing spectrum',mtconfirmation,[mbYES,mbAll,mbNo,mbCancel],0);
      if dlgres=MRCANCEL then exit;
      if dlgres=MRALL then allrewrite:=true;
     end;
     if dlgres<>MRNO then spectracalc;
    end;
   end;
  end;
  showmessage(inttostr(ib)+' spectra generated');
  checkbox8.Checked:=false;
 end else begin {single spectrum generation}
  loadfile;
  infos:='';
  if spectrumloaded then begin
   peakdef;
   dospectrum;
   picture;
  end;
 end;
end;

procedure getoptions;
var code:integer;
begin with oform do begin
v0:=strtofloat(edit9.text);v0:=1e7/v0;
sf:=strtofloat(edit1.text);
sign:=strtofloat(edit3.text);
npo:=strtoint(edit4.text);
hb:=strtofloat(edit5.text);
if checkbox1.checked then peek:='G' else if checkbox2.checked then peek:='L' else peek:='I';
if radiobutton1.checked then esc:='R' else esc:='N';
tem:=strtofloat(edit6.text);
if tem<0 then tsr:='OFF' else tsr:='ON ';
wmin:=strtofloat(edit7.text);
wmax:=strtofloat(edit8.text);
if npo>npoints0 then begin
 npo:=npoints0;
 MessageDlg('Maximum number of points is '+inttostr(npo),
 mtinformation,[mbOK],0);
end;
if radiobutton1.checked then ir:=0 else ir:=1;
if radiobutton3.checked then sp:='d';
if radiobutton4.checked then sp:='r';
if radiobutton5.checked then sp:='3';
if radiobutton6.checked then sp:='4';
if radiobutton7.checked then sp:='5';
if radiobutton8.checked then sp:='6';
if radiobutton9.checked then sp:='7';
if radiobutton10.checked then sp:='8';
if radiobutton11.checked then sp:='i';
if radiobutton12.checked then sp:='x';
if radiobutton13.checked then sp:='y';
if radiobutton14.checked then sp:='9';
val(edit2.text,acon,code);
if ((acon<>0)and(code=0)) then begin {units' constant is user-defined}
 iccon:=1;
 infos:=infos+'Default constant = '+floattostrf(acon,ffexponent,10,0)+#$D#$A;
end else begin {assign units' constants automatically}
 iccon:=0;
 if ((sp='r')or(sp='R')) then begin {VCD}
  infos:=infos+'Rotational strength supposed to be in (Debyes)^2'#$D#$A
  +'and thus spectrum is multiplied by 435'#$D#$A;
  acon:=435;
 end else begin
  if ((sp='d')or(sp='D'))then begin{absorption}
   infos:=infos+'Dipole strength supposed to be in (Debyes)^2'#$D#$A
   +'and thus spectrum is multiplied by 108.7'#$D#$A;
   acon:=108.7;
  end else begin {rest}
   acon:=1.0; infos:=infos+'Arbitrary units used for the spectrum.'#$D#$A
   +'and thus spectrum is multiplied by one'#$D#$A;
  end;
 end;
end;
infos:=infos+'Peaks should have unit areas multiplied by intensities and frequencies times the constant'#$D#$A;
end;end;

procedure Toform.CheckBox5Click(Sender: TObject);
begin
if checkbox5.checked then begin
 checkbox2.checked:=false;
 checkbox1.checked:=false;
end;
end;

procedure Toform.RadioButton5Click(Sender: TObject);
begin
edit6.text:='295';
end;

procedure Toform.RadioButton12Click(Sender: TObject);
begin
edit6.text:='295';

end;

procedure Toform.RadioButton13Click(Sender: TObject);
begin
edit6.text:='295';

end;

procedure Toform.RadioButton14Click(Sender: TObject);
begin
edit6.text:='295';
end;

procedure Toform.CheckBox6Click(Sender: TObject);
begin
 if checkbox6.checked then begin
  checkbox3.checked:=false;
  checkbox4.checked:=false;
 end;
end;

procedure Toform.SpinEdit1Change(Sender: TObject);
begin
 if spinedit1.value>np then spinedit1.Value:=np;
 if spinedit1.value<1 then spinedit1.Value:=np;
 if np>0 then edit11.Text:=floattostr(d[spinedit1.Value]);
end;

procedure Toform.Edit11KeyPress(Sender: TObject; var Key: Char);
begin
 if key=#13 then begin
  d[spinedit1.value]:=strtofloat(edit11.text);
  spinedit1.Value:=spinedit1.value+1;if spinedit1.value>np then spinedit1.Value:=np;
 end; 
end;

procedure Toform.CheckBox8Click(Sender: TObject);
begin
if CheckBox8.checked then showmessage('Spectra from all .tab files in the directory will be generated and saved!');
end;

end.
